searchNodes=[{"doc":"DuckDB API module","ref":"Duckdbex.html","title":"Duckdbex","type":"module"},{"doc":"Creates the Appender to load bulk data into a DuckDB database. This is the recommended way to load bulk data. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE table_1 (data INTEGER);&quot; ) iex&gt; { :ok , _appender } = Duckdbex . appender ( conn , &quot;table_1&quot; )","ref":"Duckdbex.html#appender/2","title":"Duckdbex.appender/2","type":"function"},{"doc":"Append row into a DuckDB database table. Any values added to the appender are cached prior to being inserted into the database system for performance reasons. That means that, while appending, the rows might not be immediately visible in the system. The cache is automatically flushed when the appender goes out of scope or when Duckdbex.appender_close(appender) is called. The cache can also be manually flushed using the Duckdbex.appender_flush(appender) method. After either flush or close is called, all the data has been written to the database system. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE table_1 (data INTEGER);&quot; ) iex&gt; { :ok , appender } = Duckdbex . appender ( conn , &quot;table_1&quot; ) iex&gt; :ok = Duckdbex . appender_add_row ( appender , [ 1 ] )","ref":"Duckdbex.html#appender_add_row/2","title":"Duckdbex.appender_add_row/2","type":"function"},{"doc":"Append multiple rows into a DuckDB database table at once. Any values added to the appender are cached prior to being inserted into the database system for performance reasons. That means that, while appending, the rows might not be immediately visible in the system. The cache is automatically flushed when the appender goes out of scope or when Duckdbex.appender_close/1 is called. The cache can also be manually flushed using the Duckdbex.appender_flush/1 method. After either flush or close is called, all the data has been written to the database system. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE table_1 (the_n1 INTEGER, the_str1 STRING);&quot; ) iex&gt; { :ok , appender } = Duckdbex . appender ( conn , &quot;table_1&quot; ) iex&gt; :ok = Duckdbex . appender_add_rows ( appender , [ [ 1 , &quot;one&quot; ] , [ 2 , &quot;two&quot; ] ] )","ref":"Duckdbex.html#appender_add_rows/2","title":"Duckdbex.appender_add_rows/2","type":"function"},{"doc":"Flush the changes made by the appender and close it. The appender cannot be used after this point Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE table_1 (the_n1 INTEGER, the_str1 STRING);&quot; ) iex&gt; { :ok , appender } = Duckdbex . appender ( conn , &quot;table_1&quot; ) iex&gt; :ok = Duckdbex . appender_add_rows ( appender , [ [ 1 , &quot;one&quot; ] , [ 2 , &quot;two&quot; ] ] ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT * FROM table_1;&quot; ) iex&gt; [ ] = Duckdbex . fetch_all ( res ) iex&gt; :ok = Duckdbex . appender_close ( appender ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT * FROM table_1;&quot; ) iex&gt; [ [ 1 , &quot;one&quot; ] , [ 2 , &quot;two&quot; ] ] = Duckdbex . fetch_all ( res )","ref":"Duckdbex.html#appender_close/1","title":"Duckdbex.appender_close/1","type":"function"},{"doc":"Commit the changes made by the appender. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE table_1 (the_n1 INTEGER, the_str1 STRING);&quot; ) iex&gt; { :ok , appender } = Duckdbex . appender ( conn , &quot;table_1&quot; ) iex&gt; :ok = Duckdbex . appender_add_rows ( appender , [ [ 1 , &quot;one&quot; ] , [ 2 , &quot;two&quot; ] ] ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT * FROM table_1;&quot; ) iex&gt; [ ] = Duckdbex . fetch_all ( res ) iex&gt; :ok = Duckdbex . appender_flush ( appender ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT * FROM table_1;&quot; ) iex&gt; [ [ 1 , &quot;one&quot; ] , [ 2 , &quot;two&quot; ] ] = Duckdbex . fetch_all ( res )","ref":"Duckdbex.html#appender_flush/1","title":"Duckdbex.appender_flush/1","type":"function"},{"doc":"Creates connection object to work with database. To work with database the connection object is requiered. Connection object hold a shared reference to database, so it is possible to forget the database reference and hold the connection reference only. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , _conn } = Duckdbex . connection ( db )","ref":"Duckdbex.html#connection/1","title":"Duckdbex.connection/1","type":"function"},{"doc":"Execute the prepared statement Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , stmt } = Duckdbex . prepare_statement ( conn , &quot;SELECT 1;&quot; ) iex&gt; { :ok , res } = Duckdbex . execute_statement ( stmt ) iex&gt; [ [ 1 ] ] = Duckdbex . fetch_all ( res )","ref":"Duckdbex.html#execute_statement/1","title":"Duckdbex.execute_statement/1","type":"function"},{"doc":"Execute the prepared statement with the given list of parameters Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , stmt } = Duckdbex . prepare_statement ( conn , &quot;SELECT 1 WHERE $1 = 1;&quot; ) iex&gt; { :ok , res } = Duckdbex . execute_statement ( stmt , [ 1 ] ) iex&gt; [ [ 1 ] ] = Duckdbex . fetch_all ( res )","ref":"Duckdbex.html#execute_statement/2","title":"Duckdbex.execute_statement/2","type":"function"},{"doc":"Returns whether extension is loaded Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; Duckdbex . extension_is_loaded ( db , &quot;parquet&quot; ) iex&gt; false","ref":"Duckdbex.html#extension_is_loaded/2","title":"Duckdbex.extension_is_loaded/2","type":"function"},{"doc":"Fetches all data from the query result. Returns empty list if there are no result to fetch. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT 1;&quot; ) iex&gt; [ [ 1 ] ] = Duckdbex . fetch_all ( res )","ref":"Duckdbex.html#fetch_all/1","title":"Duckdbex.fetch_all/1","type":"function"},{"doc":"Fetches a data chunk from the query result. Returns empty list if there are no more results to fetch. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT 1;&quot; ) iex&gt; [ [ 1 ] ] = Duckdbex . fetch_chunk ( res )","ref":"Duckdbex.html#fetch_chunk/1","title":"Duckdbex.fetch_chunk/1","type":"function"},{"doc":"Convert a duckdb hugeint record to erlang/elixir integer. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE hugeints(value HUGEINT);&quot; ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;INSERT INTO hugeints VALUES (98233720368547758080000::hugeint);&quot; ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT * FROM hugeints;&quot; ) iex&gt; [ [ hugeint = { 5325 , 4808176044395724800 } ] ] = Duckdbex . fetch_all ( res ) iex&gt; 98233720368547758080000 = Duckdbex . hugeint_to_integer ( hugeint )","ref":"Duckdbex.html#hugeint_to_integer/1","title":"Duckdbex.hugeint_to_integer/1","type":"function"},{"doc":"Convert an erlang/elixir integer to a DuckDB hugeint. For more information on DuckDB numeric types, see DuckDB Numeric Data Types For more information on DuckDB numeric types. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE hugeints(value HUGEINT);&quot; ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;INSERT INTO hugeints VALUES (98233720368547758080000::hugeint);&quot; ) iex&gt; hugeint = Duckdbex . integer_to_hugeint ( 98233720368547758080000 ) iex&gt; { :ok , res } = Duckdbex . query ( conn , &quot;SELECT * FROM hugeints WHERE value = $1&quot; , [ { :hugeint , hugeint } ] ) iex&gt; [ [ { 5325 , 4808176044395724800 } ] ] = Duckdbex . fetch_all ( res )","ref":"Duckdbex.html#integer_to_hugeint/1","title":"Duckdbex.integer_to_hugeint/1","type":"function"},{"doc":"Returns the version of the linked DuckDB, with a version postfix for dev versions Usually used for developing C extensions that must return this for a compatibility check. Examples iex&gt; Duckdbex . library_version ( ) iex&gt; &quot;v0.7.0&quot;","ref":"Duckdbex.html#library_version/0","title":"Duckdbex.library_version/0","type":"function"},{"doc":"Returns the version of the DuckDB library, for storage format version Examples iex&gt; Duckdbex . library_version ( 39 ) iex&gt; &quot;v0.6.0 or v0.6.1&quot;","ref":"Duckdbex.html#library_version/1","title":"Duckdbex.library_version/1","type":"function"},{"doc":"Returns the count of DuckDB threads This is DuckDB own native threads (not a dirty scheduler Erlang threads) Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; Duckdbex . number_of_threads ( db ) iex&gt; 8","ref":"Duckdbex.html#number_of_threads/1","title":"Duckdbex.number_of_threads/1","type":"function"},{"doc":"Opens database in the memory. Examples iex&gt; { :ok , _db } = Duckdbex . open ( )","ref":"Duckdbex.html#open/0","title":"Duckdbex.open/0","type":"function"},{"doc":"If the path to the file is specified, then opens the database in the file. If specified file does not exist, a new database file with the given name will be created automatically. If database config is specified, then opens the database in the memory with the custom database config. Examples iex&gt; { :ok , _db } = Duckdbex . open ( &quot;my_database.duckdb&quot; ) iex&gt; { :ok , _db } = Duckdbex . open ( % Duckdbex.Config { access_mode : :automatic } )","ref":"Duckdbex.html#open/1","title":"Duckdbex.open/1","type":"function"},{"doc":"Opens database in the specified file. If specified file does not exist, a new database file with the given name will be created automatically. Examples iex&gt; { :ok , _db } = Duckdbex . open ( &quot;my_database.duckdb&quot; , % Duckdbex.Config { } )","ref":"Duckdbex.html#open/2","title":"Duckdbex.open/2","type":"function"},{"doc":"Returns the Platform of the linked DuckDB library Examples iex&gt; Duckdbex . platform ( ) iex&gt; &quot;osx_amd64&quot;","ref":"Duckdbex.html#platform/0","title":"Duckdbex.platform/0","type":"function"},{"doc":"Prepare the specified query, returning a reference to the prepared statement object Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _stmt } = Duckdbex . prepare_statement ( conn , &quot;SELECT 1 WHERE $1 = 1;&quot; )","ref":"Duckdbex.html#prepare_statement/2","title":"Duckdbex.prepare_statement/2","type":"function"},{"doc":"Issues a query to the database and returns a result reference. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;SELECT 1;&quot; )","ref":"Duckdbex.html#query/2","title":"Duckdbex.query/2","type":"function"},{"doc":"Issues a query to the database with parameters and returns a result reference. Examples iex&gt; { :ok , db } = Duckdbex . open ( ) iex&gt; { :ok , conn } = Duckdbex . connection ( db ) iex&gt; { :ok , _res } = Duckdbex . query ( conn , &quot;SELECT 1 WHERE $1 = 1;&quot; , [ 1 ] )","ref":"Duckdbex.html#query/3","title":"Duckdbex.query/3","type":"function"},{"doc":"Returns the commit hash of the linked DuckDB library Examples iex&gt; Duckdbex . source_id ( ) iex&gt; &quot;b00b93f0b1&quot;","ref":"Duckdbex.html#source_id/0","title":"Duckdbex.source_id/0","type":"function"},{"doc":"Returns the version number of the database storage format Examples iex&gt; Duckdbex . storage_format_version ( ) iex&gt; 43","ref":"Duckdbex.html#storage_format_version/0","title":"Duckdbex.storage_format_version/0","type":"function"},{"doc":"","ref":"Duckdbex.html#t:appender/0","title":"Duckdbex.appender/0","type":"type"},{"doc":"","ref":"Duckdbex.html#t:connection/0","title":"Duckdbex.connection/0","type":"type"},{"doc":"","ref":"Duckdbex.html#t:db/0","title":"Duckdbex.db/0","type":"type"},{"doc":"","ref":"Duckdbex.html#t:query_result/0","title":"Duckdbex.query_result/0","type":"type"},{"doc":"","ref":"Duckdbex.html#t:reason/0","title":"Duckdbex.reason/0","type":"type"},{"doc":"","ref":"Duckdbex.html#t:statement/0","title":"Duckdbex.statement/0","type":"type"},{"doc":"DuckDB database instance configuration.","ref":"Duckdbex.Config.html","title":"Duckdbex.Config","type":"module"},{"doc":"DuckDB database instance configuration type. :access_mode : Access mode of the database. Maybe :automatic , :read_only or :read_write . Default: :automatic . :checkpoint_wal_size : Checkpoint when WAL reaches this size. Default: 16777216 (16MB). :use_direct_io : Whether or not to use Direct IO, bypassing operating system buffers. Default: false . :load_extensions : Whether extensions should be loaded on start-up. Default: true . :maximum_memory : The maximum memory used by the database system (in bytes). Default: nil (80% of System available memory) :maximum_threads : The maximum amount of native CPU threads used by the database system. Default: nil (all available). :use_temporary_directory : Whether or not to create and use a temporary directory to store intermediates that do not fit in memory. Default: true :temporary_directory : Directory to store temporary structures that do not fit in memory. Default: nil (current) :collation : The collation type of the database. Default: nil :default_order_type : The order type used when none is specified. Maybe :asc , :desc . Deafult: :asc . :default_null_order : Null ordering used when none is specified. Maybe :nulls_firs , :nulls_last . Default: :nulls_firs . :enable_external_access : Enable COPY and related commands. Default: true . :object_cache_enable : Whether or not object cache is used. Default: false . :http_metadata_cache_enable : Whether or not the global http metadata cache is used. Default: false . :force_checkpoint : Force checkpoint when CHECKPOINT is called or on shutdown, even if no changes have been made. Default: false . :checkpoint_on_shutdown : Run a checkpoint on successful shutdown and delete the WAL, to leave only a single database file behind. Default: true . :force_compression : Force a specific compression method to be used when checkpointing (if available). Maybe :auto , :uncompressed , :constant , :rle , :dictionary , :pfor_delta , :bitpacking , :fsst , :chimp , :patas . Default: :auto . :force_bitpacking_mode : Force a specific bitpacking mode to be used when using the bitpacking compression method. Maybe :auto , :constant , :constant_delta , :delta_for , :for . Default: :auto . :preserve_insertion_order : Whether or not preserving insertion order should be preserved. Default: true . :extension_directory : Directory to store extension binaries in. Default: nil . :allow_unsigned_extensions : Whether unsigned extensions should be loaded. Default: false . :immediate_transaction_mode : Start transactions immediately in all attached databases - instead of lazily when a database is referenced. Default: false . :memory_allocator : The memory allocator used by the database system. Maybe :duckdb - native DuckDB allocator or :erlang - erlang 'void *enif_alloc(size_t size)' allocator. Default: :duckdb .","ref":"Duckdbex.Config.html#t:t/0","title":"Duckdbex.Config.t/0","type":"type"},{"doc":"This is Elixir Library what embeds C++ DuckDB database into you Elixir application. DuckDB is an in-process SQL database management system designed to support analytical query workloads, also known as Online analytical processing (OLAP). It has no external dependencies, neither for compilation nor during run-time and completely embedded (like Sqlite) within a host (BEAM in our case) process. To find out where and why you could use DuckDB, please, see why DuckDB section of DuckDB docs. Also, you may find useful the DuckDB documentation . The library uses amalgamation of the DuckDB sources, which combine all sources into two files duckdb.hpp and duckdb.cpp. This is the standard source distribution of libduckdb. Amalgamation allows to work with CSV and Parquet but it does not yet include DuckDB extensions like JSON , Full Text Search , HTTPFS , SQLite Scanner , Postgres Scanner and Substrait . All NIF functions implemented as Dirty NIF DuckDB is in the active development phase, and new version of library may not open the database created by the old version. HexDocs","ref":"readme.html","title":"Duckdbex","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding duckdbex to your list of dependencies in mix.exs : def deps do [ { :duckdbex , &quot;~&gt; 0.1.0&quot; } ] end Usage Using the duckdbex is quite simple. You need to open database file, create connection, run a query and fetch the results. livebook","ref":"readme.html#installation","title":"Duckdbex - Installation","type":"extras"},{"doc":"To open the DuckDB database, you must specify the path to the DuckDB file # Open an existing database file { :ok , db } = Duckdbex . open ( &quot;exis_movies.duckdb&quot; ) If specified database file does not exist, a new database file with the given name will be created automatically. # If the specified file does not exist the new database will be created { :ok , db } = Duckdbex . open ( &quot;not_yet_exist_my_new_duckdb_database&quot; ) If you do not specify any database file the database will be created in the memory. Note that for an in-memory database no data is persisted to disk (i.e. all data is lost when you exit the app or database|connection object out of scope). # Just create database in the memory { :ok , db } = Duckdbex . open ( ) The DuckDB has a number of different options and could be configured by passing the Duckdbex.Config struct into the Duckdbex.open/1 or Duckdbex.open/2 . { :ok , _db } = Duckdbex . open ( % Duckdbex.Config { checkpoint_wal_size : 8388608 } )","ref":"readme.html#open-database","title":"Duckdbex - Open database","type":"extras"},{"doc":"With the DuckDB instance, you can create one or many Connection instances using the Duckdbex.connection/1 function. In fact, the DuckDB connection is the native OS thread (not a lightweight Elixir process). While individual connections are thread-safe, they will be locked during querying. So, it is recommended to use the different DuckDB connections in the different Elixir processees to allow for the best parallel performance. { :ok , db } = Duckdbex . open ( ) # Create a connection to the opened database { :ok , conn } = Duckdbex . connection ( db )","ref":"readme.html#create-connection","title":"Duckdbex - Create Connection","type":"extras"},{"doc":"To make a query you need call Duckdbex.query/2 passing connection reference and query string. Query parameters can be passed as list into Duckdbex.query/3 . The query call will return the reference to the result. { :ok , db } = Duckdbex . open ( ) { :ok , conn } = Duckdbex . connection ( db ) # Run a query and get the reference to the result { :ok , result_ref } = Duckdbex . query ( conn , &quot;SELECT 1;&quot; ) # Run a query with parameters { :ok , result_ref } = Duckdbex . query ( conn , &quot;SELECT 1 WHERE $1 = 1;&quot; , [ 1 ] )","ref":"readme.html#make-a-query","title":"Duckdbex - Make a Query","type":"extras"},{"doc":"To get data from result you need pass result reference from the Duckdbex.query/2 or Duckdbex.query/3 call into the Duckdbex.fetch_all/1 or Duckdbex.fetch_chunk/1 . The Duckdbex.fetch_all/1 will return all the data at once. To get data chunk by chunk you should call Duckdbex.fetch_chunk/1 . # Run a query and get the reference to the result { :ok , result_ref } = Duckdbex . query ( conn , &quot;&quot;&quot; SELECT userId, movieId, rating FROM ratings WHERE userId = $1; &quot;&quot;&quot; , [ 1 ] ) # Get all the data from the result reference at once Duckdbex . fetch_all ( result_ref ) # =&gt; [[userId: 1, movieId: 1, rating: 6], [userId: 1, movieId: 2, rating: 12]] or by chunks # Run a query and get the reference to the result { :ok , result_ref } = Duckdbex . query ( conn , &quot;SELECT * FROM ratings;&quot; ) # fetch chunk Duckdbex . fetch_chunk ( result_ref ) # =&gt; [[userId: 1, movieId: 1, rating: 6], [userId: 1, movieId: 2, rating: 12]...] # fetch next chunk Duckdbex . fetch_chunk ( result_ref ) # =&gt; [&lt;rows&gt;] ... # the data is over and fetch_chunk returns the empty list Duckdbex . fetch_chunk ( result_ref ) # =&gt; []","ref":"readme.html#fetch-result","title":"Duckdbex - Fetch Result","type":"extras"},{"doc":"Prepared statement speeding up queries that will be executed many times with different parameters. Also it allows to avoid string concatenation/SQL injection attacks. # Prepare statement { :ok , stmt_ref } = Duckdbex . prepare_statement ( conn , &quot;SELECT 1;&quot; ) # Execute statement { :ok , result_ref } = Duckdbex . execute_statement ( stmt_ref ) # Fetch result Duckdbex . fetch_all ( result_ref ) # =&gt; [[1]] or with parameters # Prepare statement { :ok , stmt_ref } = Duckdbex . prepare_statement ( conn , &quot;SELECT * FROM ratings WHERE userId = $1;&quot; ) # Execute statement { :ok , result_ref } = Duckdbex . execute_statement ( stmt_ref , [ 1 ] ) # fetch result ... # Execute statement { :ok , result_ref } = Duckdbex . execute_statement ( stmt_ref , [ 42 ] ) # fetch result ...","ref":"readme.html#prepared-statement","title":"Duckdbex - Prepared statement","type":"extras"},{"doc":"DuckDB provides several methods that allows you to easily and efficiently insert data to the database. Insert Statements CSV Files Parquet Files Appender Insert Statements This is standart way of inserting data into relational database, but DuckDB is not recommended to use this method if you are inserting more than a few records . See details . To insert bulk data into database, please, use Appender . { :ok , db } = Duckdbex . open ( ) { :ok , conn } = Duckdbex . connection ( db ) { :ok , _res } = Duckdbex . query ( conn , &quot;CREATE TABLE people(id INTEGER, name VARCHAR);&quot; ) { :ok , _res } = Duckdbex . query ( conn , &quot;INSERT INTO people VALUES (1, &#39;Mark&#39;), (2, &#39;Hannes&#39;);&quot; ) A more detailed description together with syntax diagram can be found here . CSV Files DuckDB has an embedded CSV reader that allows to load CSV files directly into database (escaping data transfering from Elixir to NIF, so ERTS doesn't involved in this). Also, DuckDB supports compressed CSV files, e.g. a gzipped file like my_csv_file.csv.gz and etc. For example we have a test.csv CSV file: FlightDate|UniqueCarrier|OriginCityName|DestCityName 1988-01-01|AA|New York, NY|Los Angeles, CA 1988-01-02|AA|New York, NY|Los Angeles, CA 1988-01-03|AA|New York, NY|Los Angeles, CA Let's load this file into database: { :ok , db } = Duckdbex . open ( ) { :ok , conn } = Duckdbex . connection ( db ) # read a CSV file from disk, auto-infer options { :ok , res } = Duckdbex . query conn , &quot;SELECT * FROM &#39;test.csv&#39;;&quot; Duckdbex . fetch_all ( res ) # will result in [ [ { 1988 , 1 , 1 } , &quot;AA&quot; , &quot;New York, NY&quot; , &quot;Los Angeles, CA&quot; ] , [ { 1988 , 1 , 2 } , &quot;AA&quot; , &quot;New York, NY&quot; , &quot;Los Angeles, CA&quot; ] , [ { 1988 , 1 , 3 } , &quot;AA&quot; , &quot;New York, NY&quot; , &quot;Los Angeles, CA&quot; ] ] or we could export data directly into CSV (escaping Elixir) Duckdbex . query conn , &quot;CREATE TABLE ontime AS SELECT * FROM &#39;test.csv&#39;;&quot; # write the result of a query to a CSV file Duckdbex . query conn , &quot;COPY (SELECT * FROM ontime) TO &#39;test.csv&#39; WITH (HEADER 1, DELIMITER &#39;|&#39;);&quot; see more examples here Parquet Files Parquet is an open source, column-oriented data file format designed for efficient data storage and retrieval. It provides efficient data compression and encoding schemes with enhanced performance to handle complex data in bulk. DuckDB has a built-in Parquet reader. Like CSV reader it works directly with the files escaping ERTS. # download parquet extension (the .so/.dll extension will be downloaded from the remote source) Duckdbex . query conn , &quot;INSTALL &#39;parquet&#39;;&quot; # load parquet extension into the app Duckdbex . query conn , &quot;LOAD &#39;parquet&#39;;&quot; # read a single parquet file Duckdbex . query conn , &quot;SELECT * FROM &#39;test.parquet&#39;;&quot; # figure out which columns/types are in a parquet file Duckdbex . query conn , &quot;DESCRIBE SELECT * FROM &#39;test.parquet&#39;;&quot; # read all files that match the glob pattern Duckdbex . query conn , &quot;SELECT * FROM &#39;test/*.parquet&#39;;&quot; # export the table contents of the entire database as parquet Duckdbex . query conn , &quot;EXPORT DATABASE &#39;target_directory&#39; (FORMAT PARQUET);&quot; you can find more examples here Appender Appender can be used to load bulk data into a DuckDB database. { :ok , db } = Duckdbex . open ( ) { :ok , conn } = Duckdbex . connection ( db ) Duckdbex . query ( conn , &quot;CREATE TABLE people(id INTEGER, name VARCHAR);&quot; ) # Create Appender for table &#39;people&#39; { :ok , appender } = Duckdbex . appender conn , &quot;people&quot; # Append two rows at once. Duckdbex . appender_add_rows appender , [ [ 2 , &quot;Sarah&quot; ] , [ 3 , &quot;Alex&quot; ] ] # Persist cached rows Duckdbex . appender_flush ( ) Any values added to the appender are cached prior to being inserted into the database system for performance reasons. That means that, while appending, the rows might not be immediately visible in the system. The cache is automatically flushed when the appender goes out of scope or when Duckdbex.appender_close/1 is called. The cache can also be manually flushed using the Duckdbex.appender_flush/1 method. After either flush or close is called, all the data has been written to the database system.","ref":"readme.html#importing-data","title":"Duckdbex - Importing Data","type":"extras"},{"doc":"Along with General-Purpose Data types DuckDB supports three nested data types: LIST , STRUCT and MAP . There is also UNION data type what implemented on top of STRUCT types, and simply keep the “tag” as the first entry. Each supports different use cases and has a different structure. You can find more examples about how to work with different types here . LIST An ordered sequence of data values of the same type. Each row must have the same data type within each LIST, but can have any number of elements. # Just select a list { :ok , r } = Duckdbex . query ( conn , &quot;SELECT [1, 2, 3];&quot; ) [ [ [ 1 , 2 , 3 ] ] ] = Duckdbex . fetch_all ( r ) # Table with columns of LIST type Duckdbex . query ( conn , &quot;CREATE TABLE list_table (int_list INT[], varchar_list VARCHAR[]);&quot; ) Duckdbex . query ( conn , &quot;INSERT INTO list_table VALUES ([1, 2], [&#39;one&#39;, &#39;two&#39;]), ([4, 5], [&#39;three&#39;, NULL]), ([6, 7], NULL);&quot; ) { :ok , r } = Duckdbex . query ( conn , &quot;SELECT * FROM list_table&quot; ) [ [ [ 1 , 2 ] , [ &quot;one&quot; , &quot;two&quot; ] ] , [ [ 4 , 5 ] , [ &quot;three&quot; , nil ] ] , [ [ 6 , 7 ] , nil ] ] = Duckdbex . fetch_all ( r ) STRUCT Conceptually, a STRUCT column contains an ordered list of other columns called “entries”. The entries are referenced by name using strings. This document refers to those entry names as keys. Each row in the STRUCT column must have the same keys. Each key must have the same type of value for each row. See more here . { :ok , r } = Duckdbex . query ( conn , &quot;SELECT {&#39;x&#39;: 1, &#39;y&#39;: 2, &#39;z&#39;: 3};&quot; ) [ [ %{ &quot;x&quot; =&gt; 1 , &quot;y&quot; =&gt; 2 , &quot;z&quot; =&gt; 3 } ] ] = Duckdbex . fetch_all ( r ) MAP MAPs are similar to STRUCTs in that they are an ordered list of “entries” where a key maps to a value. However, MAPs do not need to have the same keys present on each row, and thus open additional use cases. MAPs are useful when the schema is unknown beforehand, and when adding or removing keys in subsequent rows. Their flexibility is a key differentiator. See more here . Duckdbex . query ( conn , &quot;CREATE TABLE map_table (map_col MAP(INT, DOUBLE));&quot; ) Duckdbex . query ( conn , &quot;INSERT INTO map_table VALUES (map([1, 2], [2.98, 3.14])), (map([3, 4], [9.8, 1.6]));&quot; ) { :ok , r } = Duckdbex . query ( conn , &quot;SELECT * FROM map_table&quot; ) [ [ %{ 1 =&gt; 2.98 , 2 =&gt; 3.14 } ] , [ %{ 3 =&gt; 9.8 , 4 =&gt; 1.6 } ] ] = Duckdbex . fetch_all ( r ) UNION A UNION type (not to be confused with the SQL UNION operator) is a nested type capable of holding one of multiple “alternative” values, much like the union in C. The main difference being that these UNION types are tagged unions and thus always carry a discriminator “tag” which signals which alternative it is currently holding, even if the inner value itself is null. See more here . { :ok , _ } = Duckdbex . query ( conn , &quot;CREATE TABLE tbl1(u UNION(num INT, str VARCHAR));&quot; ) { :ok , _ } = Duckdbex . query ( conn , &quot;INSERT INTO tbl1 values (1) , (&#39;two&#39;) , (union_value(str := &#39;three&#39;));&quot; ) { :ok , r } = Duckdbex . query ( conn , &quot;SELECT u from tbl1;&quot; ) [ [ %{ &quot;num&quot; =&gt; 1 } ] , [ %{ &quot;str&quot; =&gt; &quot;two&quot; } ] , [ %{ &quot;str&quot; =&gt; &quot;three&quot; } ] ] = Duckdbex . fetch_all ( r ) ENUM The ENUM type represents a dictionary data structure with all possible unique values of a column. For example, a column storing the days of the week can be an Enum holding all possible days. Enums are particularly interesting for string columns with high cardinality. This is because the column only stores a numerical reference to the string in the Enum dictionary, resulting in immense savings in disk storage and faster query performance. See more here . { :ok , _ } = Duckdbex . query ( conn , &quot;CREATE TYPE mood AS ENUM (&#39;sad&#39;, &#39;ok&#39;, &#39;happy&#39;);&quot; ) { :ok , _ } = Duckdbex . query ( conn , &quot;CREATE TABLE person (name text, current_mood mood);&quot; ) { :ok , _ } = Duckdbex . query ( conn , &quot;INSERT INTO person VALUES (&#39;Pedro&#39;,&#39;happy&#39;), (&#39;Mark&#39;, NULL), (&#39;Pagliacci&#39;, &#39;sad&#39;), ackey&#39;, &#39;ok&#39;);&quot; ) { :ok , r } = Duckdbex . query ( conn , &quot;SELECT * FROM person WHERE current_mood = &#39;sad&#39;;&quot; ) [ [ &quot;Pagliacci&quot; , &quot;sad&quot; ] ] = Duckdbex . fetch_all ( r ) { :ok , r } = Duckdbex . query ( conn , &quot;SELECT * FROM person WHERE current_mood = $1;&quot; , [ &quot;sad&quot; ] ) [ [ &quot;Pagliacci&quot; , &quot;sad&quot; ] ] = Duckdbex . fetch_all ( r )","ref":"readme.html#data-types","title":"Duckdbex - Data Types","type":"extras"},{"doc":"DuckDB allows to load and use extensions. By default extensions are downloaded from the remote source. These extensions are verified and signed. Also you can use you own unsigned extensions. Remote installation Download and install verified signed extension from remote source # download extension binary { :ok , _ } = Duckdbex . query ( conn , &quot;INSTALL &#39;parquet&#39;;&quot; ) # load extension into the app { :ok , _ } = Duckdbex . query ( conn , &quot;LOAD &#39;parquet&#39;;&quot; ) # now you can use the extension { _ , r } = Duckdbex . query ( conn , &quot;SELECT * FROM &#39;test.parquet&#39;;&quot; ) Local installation (unsigned extension) Almost the same as above, but you must configure DuckDB to allow unsigned extension # configure DuckDB to allow unsigned extension conf = % Duckdbex.Config { allow_unsigned_extensions : true } { :ok , db } = Duckdbex . open ( conf ) { :ok , conn } = Duckdbex . open ( db ) # install unsigned extension from local source { :ok , _ } = Duckdbex . query ( conn , &quot;INSTALL &#39;/home/extensions/my_custom.duckdb_extension&#39;;&quot; ) { :ok , _ } = Duckdbex . query ( conn , &quot;LOAD &#39;/home/extensions/my_custom.duckdb_extension&#39;;&quot; ) Custom build DuckDB extensions If extension what downloaded from the remote source doesn't load because of mismatch of compiler/syslibs and etc., you can build DuckDB extensions by youself and use it as unsigned extensions. You need cmake installed. $ git clone https://github.com/duckdb/duckdb.git duckdb$ cd duckdb duckdb$ BUILD_JSON=1 make duckdb$ cp build/release/extension/json/json.duckdb_extension /home/duckdb_unsigned_extensions Now we can use this extension conf = % Duckdbex.Config { allow_unsigned_extensions : true } { :ok , db } = Duckdbex . open ( conf ) { :ok , conn } = Duckdbex . open ( db ) # load extension into the app { :ok , _ } = Duckdbex . query ( conn , &quot;INSTALL &#39;/home/duckdb_unsigned_extensions/json.duckdb_extension&#39;;&quot; ) { :ok , _ } = Duckdbex . query ( conn , &quot;LOAD &#39;/home/duckdb_unsigned_extensions/json.duckdb_extension&#39;;&quot; ) # use the extension { :ok , _ } = Duckdbex . query ( conn , &quot;SELECT * FROM read_json_objects(&#39;some_data.json&#39;);&quot; ) ... Documentation generated with ExDoc","ref":"readme.html#extensions","title":"Duckdbex - Extensions","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"}]